* PACKAGE DEDIAG  !" $B@~7ANO3X8GM-CM2r@O(B : $B8GM-CM7W;;?GCG=PNO(B
*
*"  [HIS]  92/12/28(takepiro) 
*"         93/04/30(takepiro)
*"         93/07/14(takepiro) $B%]%m%$%@%k(B, $B29EY$NGH?t@_DjJ,N%(B
*"         95/06/13(takepiro) 
*"         95/06/17(takepiro) $B:n6HJQ?t(B GD* $B$r0z?t$K(B
*"         95/06/21(takepiro) $B=PNO8GM-4X?t7W;;?tF3F~(B
*
**********************************************************************
      SUBROUTINE LDIAG
     I            (  GROWTH , FRQENC , 
     I               EIGVCR , EIGVCI ,
     I               NMKMTX , NUMEIG , NVEC   ,
     I               NMTLST , NMTMAX , 
     I               NMPLST , NMPMAX , 
     I               NMQLST , NMQMAX , 
     F               OATOR  , OAPOR  , OAT    ,
     C               NMO    , FLAPLA , UVFACT , 
     C               ARAD   , DRAD   ,
     W               GDU    , GDV    , GDW    , GDT   ,
     W               GDTOR  , GDPOR  )
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" $B3J;RE@?t(B, $BGH?t(B
#include        "zldim.F"                    !" $B78?t9TNs$NBg$-$5(B
#include        "zhdim.F"                    !" $BJ8;z?t(B
*
*"  [INPUT]
      REAL       GROWTH( MATDMX )            !" $B@.D9N((B($B8GM-CM<B?tIt(B)
      REAL       FRQENC( MATDMX )            !" $B?6F0?t(B($B8GM-CM5u?tIt(B)
      REAL       EIGVCR( MATDMX, * )         !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL       EIGVCI( MATDMX, * )         !" $B8GM-%Y%/%H%k5u?tIt(B
*
      INTEGER    NMKMTX ( NMDIM, 0:KMAX, 3 ) !" $B78?t9TNs$NE:$(;z(B
      INTEGER    NUMEIG                      !" $B8GM-CM$N?t(B
      INTEGER    NMTLST  ( NMDIM )           !" MFIX $B@.J,%j%9%H(B($B%H%m%$%@%k(B)
      INTEGER    NMPLST  ( NMDIM )           !" MFIX $B@.J,%j%9%H(B($B%]%m%$%@%k(B)
      INTEGER    NMQLST  ( NMDIM )           !" MFIX $B@.J,%j%9%H(B($B29EY(B)
      INTEGER    NMTMAX                      !" NMTLST $B$N:GBgE:$(;z(B
      INTEGER    NMPMAX                      !" NMPLST $B$N:GBgE:$(;z(B
      INTEGER    NMQMAX                      !" NMQLST $B$N:GBgE:$(;z(B
*
      LOGICAL    OATOR , OAPOR , OAT         !" $B2r@OBP>]J*M}NL(B
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" $B%9%Z%/%H%k$NE:;z=gHV(B
      REAL       FLAPLA( NMDIM  )            !" $B%i%W%i%7%"%s$N78?t(B
      REAL       UVFACT ( IDIM, JDIM )       !" u$B"*(BU $B$N%U%!%/%?!<(B
*
      REAL       ARAD  ( 0:KMAX )              !" $B#r%l%Y%k(B($B@0?t(B)
      REAL       DRAD  ( 0:KMAX )              !" $B&$#r(B($B@0?t(B)
*
      REAL       GDU   ( IDIM, JDIM, 0:KMAX )  !" $B@>Iw(B   $B#u(B
      REAL       GDV   ( IDIM, JDIM, 0:KMAX )  !" $BFnIw(B   $B#v(B
      REAL       GDW   ( IDIM, JDIM, 0:KMAX )  !" $B1tD>Iw(B $B#w(B
      REAL       GDT   ( IDIM, JDIM, 0:KMAX )  !" $B29EY(B   $B#T(B
      REAL       GDTOR ( IDIM, JDIM, 0:KMAX )  !" $B%H%m%$%@%k(B $B&7(B
      REAL       GDPOR ( IDIM, JDIM, 0:KMAX )  !" $B%]%m%$%@%k(B $B&5(B
*
*   [INTERNAL WORK]
      INTEGER    I, ITA
      LOGICAL    OLDIAG, OLDIAF, OLDIAV
      CHARACTER  FNGROW * (NFILN)       !" $B@.D9N(=PNO%U%!%$%kL>(B
      CHARACTER  FNFREQ * (NFILN)       !" $B?6F0?t=PNO%U%!%$%kL>(B
*
      CHARACTER  HFMT*16
      INTEGER    JFLDIA, NCOLS, ISTR, IEND, IINT
*
      DATA       HFMT    / '(1PE12.4)' /           !" $B=PNO=q<0(B
      DATA       JFLDIA  / 6 /                     !" $B=PNOAuCVHV9f(B
      DATA       NCOLS   / 80 /                    !" $B=PNO%+%i%`?t(B
      DATA       ISTR    / 1 /                     !" $B=PNO3+;O(B
      DATA       IEND    / 1 /
      DATA       IINT    / 1 /                     !" $B=PNO4V3V(B
*
      LOGICAL    OEIAXS
      DATA       OEIAXS / .TRUE. /
      SAVE
*
*"  < 1. $B=PNO$N%Q%i%a%?!<@_Dj(B >
*
      CALL QLDIAG
     O     (  OLDIAG , OLDIAF, OLDIAV , 
     O        FNGROW , FNFREQ             ) 
*
      IEND = NUMEIG 
*
*"  < 2. $B8GM-CM?GCG=PNO(B >
*
      IF( OLDIAG )THEN
*
         WRITE ( JFLDIA, * ) '@@@@@@@@@@@@< GROWTH RATE ',
     &                       '>@@@@@@@@@@@@@'
*
         CALL PRINTD
     I         ( JFLDIA , HFMT  , GROWTH ,
     I           ISTR   , IEND  , IINT   , 1 ,
     I           MATDMX , 1     , NCOLS          )
*
         WRITE ( JFLDIA, * ) '@@@@@@@@@@@@< FREQUENCY ', 
     &                       '>@@@@@@@@@@@@@'
*
         CALL PRINTD
     I         ( JFLDIA , HFMT  , FRQENC ,
     I           ISTR   , IEND  , IINT   , 1 ,
     I           MATDMX , 1     , NCOLS          )
*
      ENDIF
*
*"  < 3. $B8GM-CM%U%!%$%k=PNO(B >
*
      IF( OLDIAF )THEN
         IF( OEIAXS )THEN
            OEIAXS = .FALSE. 
            CALL EIGAXS
     I           ( NUMEIG )
         ENDIF
*
         CALL EIALWR     !" $B@.D9N((B, $B?6F0?tA4%b!<%I=PNO(B
     I        (  GROWTH , FRQENC , 
     I           NUMEIG ,  
     I           FNGROW , FNFREQ   ) 
      ENDIF
*
*"  < 4. $B8GM-4X?t=PNO(B >
*
      IF( OLDIAV )THEN
         DO 1000 I = 1, MIN( NUMEIG, NVEC )
            ITA = I
*
            CALL LEIVEC
     O       ( GDU    , GDV    , GDW    , GDT    ,
     O         GDTOR  , GDPOR  , 
     I         EIGVCR(1,I) , EIGVCI(1,I) ,
     I         NMKMTX , 
     I         NMTLST , NMTMAX , 
     I         NMPLST , NMPMAX , 
     I         NMQLST , NMQMAX , 
     F         OATOR  , OAPOR  , OAT    ,
     C         NMO    , FLAPLA , UVFACT , 
     C         ARAD   , DRAD                       )
*
            CALL WRRSTR         !" $B%j%9%?!<%H!&%U%!%$%k$N=q$-9~$_(B
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR ,
     I           ITA   , ITA                     )
*
 1000    CONTINUE 
      ENDIF
*
      RETURN
      END
**********************************************************************
      SUBROUTINE QLDIAG
     O           (  OLDIAG , OLDIAF, OLDIAV , 
     O              FNGR   , FNFR             ) 
*
      IMPLICIT NONE
*
*   [PARAM] 
#include        "zhdim.F"                    !" $BJ8;z?t(B
**  [OUTPUT]
      LOGICAL    OLDIAG                 !" $B8GM-CM?GCG=PNO%9%$%C%A(B
      LOGICAL    OLDIAF                 !" $B8GM-CM%U%!%$%k=PNO%9%$%C%A(B
      LOGICAL    OLDIAV                 !" $B8GM-4X?t%U%!%$%k=PNO%9%$%C%A(B
      CHARACTER  FNGR * (NFILN)         !" $B@.D9N(=PNO%U%!%$%kL>(B
      CHARACTER  FNFR * (NFILN)         !" $B?6F0?t=PNO%U%!%$%kL>(B
*
*  [INTERNAL WORK]
      LOGICAL    OEIGEN                 !" $B8GM-CM?GCG=PNO%9%$%C%A(B
      LOGICAL    OEIGFI                 !" $B8GM-CM%U%!%$%k=PNO%9%$%C%A(B
      LOGICAL    OEIVEC                 !" $B8GM-4X?t%U%!%$%k=PNO%9%$%C%A(B
      CHARACTER  FNGROW * (NFILN)       !" $B@.D9N(=PNO%U%!%$%kL>(B
      CHARACTER  FNFREQ * (NFILN)       !" $B?6F0?t=PNO%U%!%$%kL>(B
*
      NAMELIST   / NMLDIA / OEIGEN, OEIGFI, OEIVEC, FNGROW, FNFREQ
*
      INTEGER    IFPAR, JFPAR
      LOGICAL    OFIRST
      DATA       OFIRST  / .TRUE. /
*
      SAVE
*
*"         < 1. NAMELIST $B$NFI$_9~$_(B >
*
      IF( OFIRST )THEN
         OFIRST = .FALSE.
*
         OEIGEN = .TRUE.
         OEIGFI = .FALSE.
         OEIVEC = .FALSE.
         FNGROW = ' '
         FNFREQ = ' '
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMLDIA, END=1190 )
 1190    WRITE  ( JFPAR, NMLDIA  )
      ENDIF
*
      OLDIAG = OEIGEN
      OLDIAF = OEIGFI
      OLDIAV = OEIVEC
      FNGR   = FNGROW
      FNFR   = FNFREQ
*
      RETURN
      END
